44d700080975bbc626bc486e9f47738ad5afbaed
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
43 typeset dvdname=""
44 typeset debug=""
45 typeset dest=""
46 typeset isofile=""
47 typeset vobfile=""
48 typeset dvdpath=""
49 typeset aspect=""
50 typeset SCALE=""
51 typeset CROP=""
52 typeset profile="hdtv"
53 typeset extension=""
54 typeset -i keep_isofile=0
55 typeset -i keep_vobfile=0
56 typeset -i keep_dvdfolder=0
57 typeset -i keep_intermediate_files=0
58 typeset -i make_final_dest_vob=0
59 typeset -i make_final_dest_iso=0
60 typeset -i make_final_dest_folder=0
61 typeset -i make_final_dest_comp=0
62 typeset -i errors=0
63 typeset -i show_usage=0
64 typeset -i mirror_mode=0
65 typeset -i target_bitrate=0
66 typeset -i target_size=0
67 typeset -i audio_2ch=0
68 typeset -i invalid_feature_title=0
69 typeset -i feature_title_override=0
70 typeset -i mplayer_dumpstream_incompatibility=0
71
72 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
73 do
74     case $opt in
75         (n)     dvdname=$OPTARG;;
76         (d)     dest=$OPTARG;;
77         (b)     target_bitrate=$OPTARG;;
78         (s)     target_size=$OPTARG;;
79         (2)     audio_2ch=1;;
80         (v)     make_final_dest_vob=1;;
81         (i)     make_final_dest_iso=1;;
82         (f)     make_final_dest_folder=1;; 
83         (x)     make_final_dest_comp=1;;
84         (m)     mirror_mode=1;;
85         (k)     keep_intermediate_files=1;;
86         (t)     feature_title_override=$OPTARG;;
87         (a)     aspect=$OPTARG;;
88         (p)     profile=$OPTARG;;
89         (e)     extension=$OPTARG;;
90         (w)     set -$opt;;
91         (h)     show_usage=1;;
92         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
93         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
94     esac
95 done
96
97 shift $((OPTIND-1))
98
99 function usage() {
100     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
101     echo >&2 "Revision $REV"
102     echo >&2 "Options:"
103     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
104     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
105     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
106     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
107     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
108     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
109     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
110     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
111     echo >&2 "                 - hdtv = AVI, Xvid codec, 2 pass encoding (default)"
112     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, 576:320 scaling"
113     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .hdtv, .ipod, etc)"
114     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
115     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
116     echo >&2 "                 The default operation is non-mirror mode where only the main"
117     echo >&2 "                 feature title will be ripped."
118     echo >&2 "   -v            Make the final image a DVD VOB file"
119     echo >&2 "   -i            Make the final image a DVD ISO file"
120     echo >&2 "   -f            Make the final image a DVD folder"
121     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
122     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
123     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
124     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
125     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
126     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
127     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
128     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
129     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
130     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
131     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
132     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
133     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
134     echo >&2 ""
135     exit 2
136 }
137
138 if (($errors)) || (($show_usage))
139 then
140   usage
141 fi
142
143 # Sanity Check - Command Line Options 
144 if [ "$dest" == "" ]; then
145   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
146   usage
147 fi
148
149 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
150   echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
151   usage
152 fi
153
154 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
155   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
156   usage
157 fi
158
159 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
160    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
161   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
162   usage
163 fi
164
165 if [ $mirror_mode -eq 1 ]; then
166   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
167      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
168     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
169     usage
170   fi
171 fi
172
173 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
174 if [ "$aspect" != "" ]; then
175   echo "$aspect" | grep -q "x"
176   if [ $? == 0 ]; then
177     echo "-E- You must specify the aspect option with a value whose format is W:H"
178     exit 1
179   fi
180   echo "$aspect" | grep -q ":"
181   if [ $? != 0 ]; then
182     SCALE=",scale -zoom -xy $aspect"
183   else
184     SCALE=",scale=$aspect"
185   fi
186 fi
187
188
189 # Sanity Check - Key executables
190 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
191 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
192 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
193 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
194 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
195 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
196 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
197 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
198
199 ##############################################################################################
200
201 typeset -i ripdvd
202 if [ -z "$dvdname" ]; then
203   # make sure the DVD device is accessible
204   volname $dev > /dev/null 2>&1
205   if [ $? != 0 ]; then
206     echo "-E- Can't access the DVD device $dev"
207     exit 1
208   fi
209   # now capture the volume name from the device
210   dvdname=`volname $dev | awk '{ print $1 }'`
211   ripdvd=1
212 else 
213   # check to see if dvdname is a full path to a real directory
214   # if it is, set dvdname and dvdpath appropriately
215   if [ -d "$dvdname" ]; then
216     dvdpath="$dvdname"
217     dvdname=`basename "$dvdname"`
218     keep_dvdfolder=1
219     if [ -z "$dvdname" ]; then
220      echo "-E- Unable to extract dvdname from path: $dvdpath"
221      exit 1
222     fi
223     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
224       echo "-E- You must supply a full path to a valid DVD folder with this option"
225       exit 1
226     fi
227   fi
228
229   # Check to see if dvdname is a full path to a file
230   if [ -f "$dvdname" ]; then
231     valid_file=0
232
233     # check to see if dvdname is a full path to an MPG2 (VOB) file
234     # if it is, set dvdname and vobfile appropriately
235     file "$dvdname" | grep -q "MPEG"
236     if [ $? == 0 ]; then
237       # It is a valid MPEG2 file, now strip the extension off our dvdname
238       vobfile="$dvdname"
239       dvdname=`basename "$dvdname"`
240       dvdname=${dvdname%.[^.]*}
241       keep_vobfile=1
242       valid_file=1
243     fi
244
245     # check to see if dvdname is a full path to an ISO file
246     # if it is, set dvdname and isofile appropriately
247     file "$dvdname" | grep -q "ISO"
248     if [ $? == 0 ]; then
249       # It is a valid ISO file, now strip the extension off our dvdname
250       isofile="$dvdname"
251       dvdname=`basename "$dvdname"`
252       dvdname=${dvdname%.[^.]*}
253       keep_isofile=1
254       valid_file=1
255     fi    
256
257     # If we didn't find a handler for the file above, complain
258     if [ $valid_file -eq 0 ]; then
259       echo "-E- Unsupported file type: $vobfile"
260       exit 1
261     fi
262   fi
263   ripdvd=0
264 fi
265
266 # remove bad characters from the dvdname
267 dvdname=${dvdname%.} # remove trailing '.' character
268
269 # add the suffix extension to the end of the dvdname
270 dvdname=$dvdname$extension
271
272 # make a "safe" dvdname (remove special characters)
273 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
274
275 # Make sure we have a non-empty dvdname
276 if [ -z "$dvdname" ]; then
277   echo "-E- unable to determine dvdname"
278   exit 1
279 fi
280
281 # make sure our vobfile value is set
282 if [ -z "$vobfile" ]; then
283   vobfile="$dest/$dvdname.VOB"
284 fi
285
286 # set up some variables to hold various logfiles
287 logfile="$logdir/$dvdname.log"
288 passlogfile="$tmpdir/$safedvdname.log"
289 ddrescuelog=`tempfile`
290 dvdauthorlog=`tempfile`
291 encodelog=`tempfile`
292 dumplog=`tempfile`
293
294 # create the tmpdir if it doesn't already exist
295 if [ ! -d "$tmpdir" ]; then
296   mkdir -p "$tmpdir"
297   if [ $? != 0 ]; then
298     echo "-E- Unable to create the tmpdir: $tmpdir"
299     exit 1
300   fi
301 fi
302
303 # create the logdir if it doesn't already exist
304 if [ ! -d "$logdir" ]; then
305   mkdir -p "$logdir"
306   if [ $? != 0 ]; then
307     echo "-E- Unable to create the logdir: $logdir"
308     exit 1
309   fi
310 fi
311
312 ##############################################################################################
313 # cleanup functions
314 ##############################################################################################
315 cleanup() { 
316   if [ $keep_intermediate_files -eq 0 ]; then
317     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
318     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
319     [[ -e "$encodelog" ]] && rm -f "$encodelog"
320     [[ -e "$dumplog" ]] && rm -f "$dumplog"
321   else
322     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
323     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
324     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
325     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
326   fi
327   echo ""
328 }
329
330 fatal_and_exit() {
331   if [[ -z "$1" ]]; then
332     msg="-E- control-c killed us"
333   else
334     msg=$1
335   fi
336   echo -e 2>&1 "$msg" | tee -a "$logfile"
337   if [[ -n "$mailto" ]]; then
338     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
339   fi
340   exit 1
341 }
342
343 # Call our cleanup functions on INT and EXIT signals
344 trap fatal_and_exit INT
345 trap cleanup EXIT
346
347 ##############################################################################################
348 # processing functions
349 ##############################################################################################
350 function make_dvd_iso_image {
351
352   isofile="$1"
353
354   # check to see if we have a dvdpath to rip from instead of $dev
355   if [ -z "$dvdpath" ]; then
356     # load the CSS codes in the DVD drive 
357     lsdvd $dev >> "$logfile"
358     if [ $? != 0 ]; then
359       fatal_and_exit "-E- lsdvd $dev failed" 
360     fi
361
362     # read the DVD, ignoring/skipping CRC errors
363     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
364     if [ $? != 0 ]; then
365       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
366     fi
367     cat "$ddrescuelog" >> "$logfile"
368   else
369     # rip from a path instead
370     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
371   fi
372 }
373
374 function make_dvd_iso_image_from_folder {
375   
376   src="$1"
377   dst="$2"
378   handle_error=$3
379   
380   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
381
382   # make an iso image out of our directory
383   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
384   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
385
386   # set the audio languages from the iso if it exists and is non-zero in size
387   if [ -s "$dst" ]; then
388     get_feature_title "$dst"
389     get_audio_id_from_iso "$dst"
390   fi
391
392   # make sure we were able to create the iso image from the folder given to us
393   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
394     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
395     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
396     # remove the bad iso file
397     [[ -e "$dst" ]] && rm -f "$dst"
398     # get the feature title from the DVD folder
399     get_feature_title "$dvdpath"
400     # create our main VOB file from the ISO
401     create_main_vob_with_mplayer "$dvdpath" 
402     # get our audio id from the VOB file
403     get_audio_id_from_vob "$vobfile"
404   fi
405 }
406
407 function make_dvdbackup_folder_image {
408   # extract the feature title from the DVD image
409   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
410   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
411   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
412   if [ $? != 0 ]; then
413     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
414   fi
415 }
416
417 function make_dvdauthor_folder_image {
418   # create a new DVD video of the feature title
419   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
420   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
421   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
422   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
423
424   # There is a chance that dvdauthor won't like some of the VOBs.
425   # We can't tell ahead of time which ones it will choke on. 
426   # So, we need to run it over and over again until it can process
427   # all the VOBs. If it can't handle one of them, run it through
428   # mencoder to fix it and try again. These errors are typically
429   # present due to the copy protection that ddrescue removed.
430   grep -q "SCR moves" $dvdauthorlog
431   while [ $? == 0 ]; do
432     # fix bad vobs that get the "SCR moves backwards" error:
433     #  STAT: Processing VTS_01_0.VOB...
434     #  ERR:  SCR moves backwards, remultiplex input.
435     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
436     if [[ ! -f "$badvob" ]]; then
437       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
438     fi
439     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
440     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
441     mv -f $badvob.fixed $badvob
442     echo "-> Creating DVD video $dest/$dvdname"
443     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
444     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
445     grep -q "SCR moves" $dvdauthorlog
446   done
447 }
448
449 function get_feature_title {
450   source="$1"
451   # if a feature title was given on the command line, use it
452   if [ $feature_title_override -ne 0 ]; then
453     feature_title=$feature_title_override
454     return 0
455   fi
456   # otherwise, use lsdvd to figure it out
457   if [ $ripdvd -eq 1 ]; then
458     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
459   else 
460     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
461   fi
462 }
463
464 function create_main_vob_with_cat {
465   # cd to the feature title DVD folder
466   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
467   if [ $? != 0 ]; then
468     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
469   fi
470
471   # concatenate all the VOBs together into 1 giant VOB
472   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
473   cat $vobs > "$tmpdir/$dvdname.VOB"
474
475   # cd back to the dir we started from
476   popd > /dev/null 2>&1
477 }
478
479 function create_main_vob_with_mplayer {
480
481   # argument processing  
482   source="$1"
483   remove_dumplog=$2
484
485   # make sure we have a valid feature title
486   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
487     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
488   fi
489
490   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
491   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
492     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
493     msg="$msg We also detected another condition that requires us to use dumpstream. "
494     msg="$msg\n    Unable to rip this DVD in the mode you requested."
495     fatal_and_exit "$msg"
496   fi
497
498   # use mplayer to create the main VOB file
499   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
500   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
501   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
502   if [ $? != 0 ]; then
503     cat $dumplog | grep -v "^A:" >> "$logfile"
504     fatal_and_exit "-E- Mplayer Failed"
505   fi
506   cat $dumplog | grep -v "^A:" >> "$logfile"
507   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
508 }
509
510 function get_audio_id_from_iso {
511   # Adjust our audio ID to find the english audio stream
512   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
513   iso="$1"
514   aidcheck=`tempfile`
515   aid=128
516   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
517   grep -q "aid: $aid" $aidcheck
518   while [ $? == 1 ] && [ $aid -lt 159 ]; do
519     (( aid = aid + 1 ))
520     grep -q "aid: $aid" $aidcheck
521   done
522   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
523   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
524   # mencoder default DVD audio track language selection (english)
525   lang_opts="-aid $aid -alang en"
526 }
527
528 function get_crop_from_iso { 
529   FRAMES=10000
530   echo "-> Detecting black frame border crop value from ISO file"
531   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
532   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
533   [[ -e "md5sums" ]] && rm -f "md5sums"
534   CROP=`cat $dumplog | grep CROP | tail -1`
535   echo "   Found crop value of $CROP" >> "$logfile"
536   CROP=${CROP#* crop=}
537   CROP=${CROP%%\).*}
538   typeset -i CROPCHECK
539   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
540   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
541   if [ -z "$CROP" ]; then
542     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
543   fi
544   if [ $CROPCHECK -lt 0 ]; then 
545     CROP=""
546   else 
547     CROP=",crop=$CROP"
548   fi
549   echo "   Setting mencoder crop filter to: $CROP"
550 }
551
552 function get_crop_from_vob { 
553   FRAMES=10000
554   echo "-> Detecting black frame border crop value from VOB file"
555   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
556   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
557   [[ -e "md5sums" ]] && rm -f "md5sums"
558   CROP=`cat $dumplog | grep CROP | tail -1`
559   echo "   Found crop value of $CROP" >> "$logfile"
560   CROP=${CROP#* crop=}
561   CROP=${CROP%%\).*}
562   typeset -i CROPCHECK
563   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
564   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
565   if [ -z "$CROP" ]; then
566     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
567   fi
568   if [ $CROPCHECK -lt 0 ]; then 
569     CROP=""
570   else 
571     CROP=",crop=$CROP"
572   fi
573   echo "   Setting mencoder crop filter to: $CROP"
574 }
575
576 function get_audio_id_from_vob {
577   # Adjust our audio ID to find the english audio stream
578   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
579   vob="$1"
580   aidcheck=`tempfile`
581   aid=128
582   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
583   grep -q "Found audio stream: $aid" $aidcheck
584   while [ $? == 1 ] && [ $aid -lt 159 ]; do
585     (( aid = aid + 1 ))
586     grep -q "Found audio stream: $aid" $aidcheck
587   done
588   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
589   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
590   # mencoder default DVD audio track language selection (english)
591   lang_opts="-aid $aid -alang en"
592 }
593
594 function check_vob_for_corrupted_start {
595   # check to see if the beginning of the DVD has a form of copy protection
596   # where they have deliberately broken the first X number of frames of the DVD.
597   # If we don't skip these, our resulting VOB file will not play.
598   badvobcheck=`tempfile`
599   endpos=360
600   skip=0
601   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
602   if [ $? != 0 ]; then
603     fatal_and_exit "-E- Mencoder Failed"
604   fi
605   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
606   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
607     (( skip = skip + 5 ))
608     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
609     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
610     if [ $? != 0 ]; then
611       fatal_and_exit "-E- Mencoder Failed"
612     fi
613     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
614   done
615   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
616
617   # cat the giant VOB into mencoder to create a playable VOB file
618   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
619   if [ $? != 0 ]; then
620     fatal_and_exit "-E- Mencoder Failed"
621   fi
622 }
623
624 function check_vob_for_completeness {
625   # check to make sure we got out a complete VOB.
626   # there is another kind of copy protection where the VOB's may
627   # have "MPG EOF" frames in the middle of the stream. 
628   # this causes mencoder to not process the entire VOB, and exit without any errors.
629   # detect this by seeing how much smaller the dst vob is from the src vob.
630   MAX_FILESIZE_DELTA_PERCENT=70
631   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
632   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
633   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
634   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
635     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
636     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
637     create_main_vob_with_mplayer "$isofile"
638     [[ -e "$dumplog" ]] && rm -f $dumplog
639     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
640     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
641     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
642       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
643     fi
644   fi
645 }
646
647 function check_vob_for_too_many_video_packets {
648   # If our earlier algorithm to work around this failed, throw an error.
649   # check to see if this DVD has a protection scheme we don't know how to work around
650   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
651   # for some reason, the video is black, while the audio rolls, then the video finally comes
652   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
653   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
654   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
655   grep -q "Too many video packets in the buffer:" "$logfile"
656   if [ $? == 0 ]; then
657     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
658     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
659     create_main_vob_with_mplayer "$isofile"
660     grep -q "Too many video packets in the buffer:" $dumplog
661     if [ $? == 0 ]; then
662       [[ -e "$dumplog" ]] && rm -f $dumplog
663       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
664     fi
665     [[ -e "$dumplog" ]] && rm -f $dumplog
666   fi
667 }
668
669 function check_vob_for_a52_crc_errors {
670   # Let's see if we can playback our newly created VOB file without any errors.
671   # if there are issues, let's detect them now, and try to recreate the VOB
672   # there are some forms of copy protection that have missed above, that evidence
673   # themselves when we try to playback the VOB file. This was added to deal with
674   # the "a52: CRC check failed" copy protection scheme.
675   MAX_ERRORS=10
676   ENDPOS=120
677   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
678   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
679   cat $dumplog | grep -v "^A:" >> "$logfile"
680   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
681   if [ $errors -gt $MAX_ERRORS ]; then
682     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
683     create_main_vob_with_mplayer "$isofile"
684     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
685     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
686     if [ $? != 0 ]; then
687       cat $dumplog | grep -v "^A:" >> "$logfile"
688       fatal_and_exit "-E- Mplayer Failed"
689     fi
690     cat $dumplog | grep -v "^A:" >> "$logfile"
691     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
692     if [ $errors -gt $MAX_ERRORS ]; then
693       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
694     fi
695   fi
696   [[ -e "$dumplog" ]] && rm -f $dumplog
697 }
698
699 function calculate_bitrate_from_target_size {
700   # determine what our bitrate needs to be if a target size was specified instead
701   if [ $target_size -ne 0 ]; then
702     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
703     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
704     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
705   fi
706 }
707
708 function create_dvdauthor_dvd_xml_file {
709   # make a dvdauthor xml menu file to create a valid DVD video from 
710   # this script does a good job, but we'll still need to clean it up a bit after it runs
711   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
712   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
713   if [ $? != 0 ]; then
714     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
715   fi
716
717   # replace the first line of the xml file to remove the bad dest path
718   awk -v line=1 -v new_content="<dvdauthor>" '{
719     if (NR == line) {
720       print new_content;
721     } else {
722       print $0;
723     }
724   }' dvd.xml > dvd.xml.new
725   mv -f dvd.xml.new dvd.xml
726   if [ $? != 0 ]; then
727     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
728   fi
729
730   # remove the "<video " property line from the xml file
731   cat dvd.xml | grep -v "<video" > dvd.xml.new
732   mv -f dvd.xml.new dvd.xml
733   if [ $? != 0 ]; then
734     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
735   fi
736   
737   # remove the extra <pgc>..</pgc> pairs
738   cat dvd.xml | awk 'BEGIN {x=1}
739   {
740     if ($0~"</pgc>") {x=0}
741     if (x==1) {print $0}
742     if ($0~"<pgc>") {x=1}
743   }' > dvd.xml.new
744   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
745   mv -f dvd.xml.new dvd.xml
746   if [ $? != 0 ]; then
747     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
748   fi
749
750   # remove the VTS_*_0.VOB file as this is just the main menu video clip
751   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
752   mv -f dvd.xml.new dvd.xml
753   if [ $? != 0 ]; then
754     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
755   fi
756 }
757
758 function check_for_mplayer_dumpstream_incompatibility {
759
760   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
761
762   if [ ! -e "$vobfile" ]; then
763     # mplayer dumpstream does not work on DVDs that obscure the feature title.
764     # A DVD that has 99 titles, where the longest title isn't the main feature
765     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
766     # out what the feature title is. This script will run through that flow if we
767     # set use_mplayer_dumpstream to 0. Check for this here.
768     if [ $ripdvd -eq 1 ]; then
769       lsdvd $dev | grep -q "Title: 99"
770     else
771       lsdvd "$isofile" | grep -q "Title: 99"
772     fi
773     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
774     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
775       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
776         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
777         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
778         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
779         invalid_feature_title=1
780       else 
781         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
782         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
783         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
784         use_mplayer_dumpstream=0
785         invalid_feature_title=1
786       fi
787       return
788     fi
789   fi
790
791   # There is another form of protection that causes the mplayer dumpstream to fail. 
792   # This can be detected by telling mplayer to parse the VOB file by copying its audio
793   # video streams to a dummy output file (/dev/null). Do that here to check for that 
794   # problem before continuing.
795   if [ -e "$vobfile" ]; then
796     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
797     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
798     grep -q "Too many audio packets in the buffer" $dumplog
799     if [ $? == 0 ]; then
800       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
801       use_mplayer_dumpstream=0
802       mplayer_dumpstream_incompatibility=1
803     fi
804     [[ -e "$dumplog" ]] && rm -f $dumplog
805   fi
806 }
807
808 # encode the vob file into a compressed file format
809 function compress_vob_file {
810   typeset -i found_profile=0
811    
812   if [ "$profile" == "hdtv" ]; then
813     # DIVX 2 pass encoding
814     found_profile=1
815     final_output_file="$dest/$dvdname.avi"
816     mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
817     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
818     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
819     mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
820     video_encoder_opts[0]="bitrate=$target_bitrate"
821     video_encoder_opts[1]="threads=$mencoder_threads"
822     video_encoder_opts[2]="chroma_opt"
823     video_encoder_opts[3]="vhq=4"
824     video_encoder_opts[4]="bvhq=1"
825     video_encoder_opts[5]="quant_type=mpeg"
826     video_encoder_opts[6]="autoaspect"
827     for OPTS in "${video_encoder_opts[@]}"; do 
828       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
829     done
830
831     if [ $audio_2ch -eq 0 ]; then
832       # These options produce good 6 channel audio for linux and windows
833       mencoder_audio_opts="-oac copy"
834       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
835       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
836       mencoder_audioch_opts[1]="-af channels=6"
837       mencoder_audioch_opts[2]=""
838     else
839       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
840       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
841       mencoder_audioch_opts[0]=""
842     fi
843  
844   fi
845
846   if [ "$profile" == "ipod" ]; then
847     # MP4 encoding 
848     found_profile=1
849     SCALE=",scale=576:320"
850     final_output_file="$dest/$dvdname.mp4"
851     mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
852     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
853     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
854     mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
855     video_encoder_opts[0]="bitrate=$target_bitrate"
856     video_encoder_opts[1]="threads=$mencoder_threads"
857     video_encoder_opts[2]="vbv_maxrate=1500"
858     video_encoder_opts[3]="vbv_bufsize=2000"
859     video_encoder_opts[4]="nocabac"
860     video_encoder_opts[5]="me=umh"
861     video_encoder_opts[6]="subq=6"
862     video_encoder_opts[7]="frameref=6"
863     video_encoder_opts[8]="trellis=1"
864     video_encoder_opts[9]="level_idc=30"
865     video_encoder_opts[10]="global_header"
866     for OPTS in "${video_encoder_opts[@]}"; do 
867       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
868     done
869
870     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
871     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
872   fi
873
874   if [ $found_profile -eq 0 ]; then
875     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
876   fi
877
878   # Do not edit this line. $mencoder_video_encoder_opts must be last
879   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
880   mencoder_retval=0
881
882   for PASS in 1 2 
883   do 
884     # Set some options based on which pass we are in
885     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
886     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
887     [ $PASS -eq 1 ] && output_file="/dev/null"
888     [ $PASS -eq 2 ] && output_file="$final_output_file"
889   
890     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
891     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
892     do
893       echo -e "   Encoding pass $PASS"
894       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
895       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
896       mencoder_retval=$? 
897       grep -q "\[channels\] Invalid" $encodelog
898       if [ $? != 0 ]; then          
899         break;
900       else
901         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
902       fi
903     done
904       
905     if [ $mencoder_retval != 0 ]; then
906       fatal_and_exit "-E- Unhandled mencoder error"
907     fi
908
909     # Concatenate the encode log to our main log file, greping out unwanted lines
910     cat $encodelog | grep -v "Pos:" >> "$logfile"
911
912   done
913 }
914
915 function fill_mythvideo_metadata {
916
917   # This function must be passed the filename as an argument
918   # The filename must be a full path to the file
919   filename="$1"
920
921   # Make sure the fill mythvideo metadata option has been set to 1
922   if [ $fill_mythvideo_metadata -eq 0 ]; then
923     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
924     return 0
925   fi
926
927   # If the fill mythvideo metadata script is present, run it
928   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
929   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
930     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
931     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
932   else
933     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
934     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
935   fi
936 }
937
938 # remove the intermediate VOB file
939 function remove_intermediate_vob_file {
940   if [ $keep_intermediate_files -eq 0 ]; then
941     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
942   else
943     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
944   fi
945 }
946
947 # remove the original DVD image 
948 function remove_intermediate_iso_file {
949   [[ $keep_isofile -eq 1 ]] && return 1
950   if [ $keep_intermediate_files -eq 0 ]; then
951     [[ -e "$isofile" ]] && rm "$isofile"
952   else
953     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
954   fi
955 }
956
957 # remove the intermediate dvdbackup folder
958 function remove_intermediate_dvdbackup_folder {
959   if [ $keep_intermediate_files -eq 0 ]; then
960     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
961   else
962     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
963   fi
964 }
965
966 ##############################################################################################
967 # MAIN
968 ##############################################################################################
969
970 # Make a note of when this DVD rip started
971 date=`date`
972 echo -e "\n$date DVD rip started" >> "$logfile"
973
974 # Rip the DVD - Mirror Mode
975 if [ $mirror_mode -eq 1 ]; then
976   echo "-> Ripping DVD $dvdname to $dest"
977
978   # use ddrescue to make an ISO image of the disk
979   make_dvd_iso_image "$dest/$dvdname.iso"
980
981   # add this video data to the mythtv DB
982   fill_mythvideo_metadata "$dest/$dvdname.iso" 
983
984   # eject the disk upon completion
985   eject -T $dev
986
987   date=`date`
988   echo "$date DVD rip completed" | tee -a "$logfile"
989
990   if [[ -n "$mailto" ]]; then
991     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
992   fi
993
994 fi
995
996 # Rip the DVD - Main Title Feature Only
997 if [ $mirror_mode -eq 0 ]; then
998
999   # Rip image from DVD
1000   if [ $ripdvd -eq 1 ]; then
1001     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1002     # use ddrescue to make an ISO image of the disk
1003     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1004   fi
1005
1006   # Rip image from DVD path
1007   if [ -n "$dvdpath" ]; then
1008     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1009     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1010   fi
1011
1012   # make sure our isofile value is set
1013   if [ -z "$isofile" ]; then
1014     isofile="$tmpdir/$dvdname.iso"
1015   fi
1016      
1017   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1018
1019     if [ ! -e "$vobfile" ]; then
1020       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1021       
1022       # get the feature title from the ISO
1023       get_feature_title "$isofile"
1024  
1025       # get the crop value from the ISO
1026       get_crop_from_iso
1027
1028       # check for mplayer dumpstream incompatibilities
1029       # if they exist, this method will set this mode to 0.
1030       check_for_mplayer_dumpstream_incompatibility
1031
1032       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1033
1034         # get our audio id from the ISO file
1035         get_audio_id_from_iso "$isofile"
1036
1037         # create our main VOB file from the ISO
1038         create_main_vob_with_mplayer "$isofile"
1039      
1040         # remove the intermediate VOB file
1041         remove_intermediate_vob_file
1042
1043         # it's possible that our VOB is still corrupted in some manner
1044         # check to make sure it is still a good VOB before continuing.
1045         check_for_mplayer_dumpstream_incompatibility
1046
1047       fi
1048  
1049       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1050
1051         # use dvdbackup to make a DVD folder of the feature title
1052         make_dvdbackup_folder_image
1053   
1054         # create our main VOB file
1055         create_main_vob_with_cat
1056
1057         # get our audio id from the VOB file
1058         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1059   
1060         # check for corrupted VOB start
1061         check_vob_for_corrupted_start
1062  
1063         # check to make sure our VOB is complete
1064         check_vob_for_completeness
1065
1066         # check to make sure our VOB doesn't have too many video packets
1067         check_vob_for_too_many_video_packets
1068
1069         # check to make sure our VOB doesn't have a52 crc errors
1070         check_vob_for_a52_crc_errors
1071
1072         # remove the intermediate VOB file
1073         remove_intermediate_vob_file
1074
1075       fi
1076
1077       # remove the intermediate ISO file
1078       remove_intermediate_iso_file
1079
1080     else
1081       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1082       # get our audio id from the VOB file
1083       get_audio_id_from_vob "$vobfile"
1084       # get the crop value from the VOB
1085       get_crop_from_vob
1086     fi
1087
1088     # encode the VOB file to a compressed file format
1089     if [ $make_final_dest_comp -eq 1 ]; then
1090       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1091
1092       # determine what our bitrate needs to be if a target size was specified instead
1093       calculate_bitrate_from_target_size        
1094      
1095       # encode the vob file into a compressed file format
1096       compress_vob_file
1097
1098       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1099         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1100         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1101       else
1102         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1103         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1104       fi
1105     fi
1106
1107   # add this video data to the mythtv DB
1108   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1109   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1110     
1111   else
1112
1113   # use dvdbackup to make a DVD folder of the feature title
1114   make_dvdbackup_folder_image
1115
1116   # cd to the feature title DVD folder
1117   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1118   if [ $? != 0 ]; then
1119     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1120   fi
1121   
1122   # create the dvd.xml file for dvdauthor
1123   create_dvdauthor_dvd_xml_file  
1124
1125   # make the final DVD folder image
1126   make_dvdauthor_folder_image
1127
1128   # add this video data to the mythtv DB
1129   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1130  
1131   # cd back to the dir we started from
1132   popd > /dev/null 2>&1
1133
1134   if [ $make_final_dest_iso -eq 1 ]; then
1135
1136     # make an iso image out of our directory
1137     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1138    
1139     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1140     if [ -s "$dest/$dvdname.iso" ]; then
1141       if [ $make_final_dest_folder -eq 0 ]; then
1142         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1143         # remove the folder of the DVD image now that we have a .iso version of it
1144         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1145       fi
1146     else
1147       # we created an empty iso file, remove it
1148       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1149       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1150       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1151     fi
1152  
1153     # add this video data to the mythtv DB
1154     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1155
1156   fi
1157
1158   fi
1159
1160   # remove the ddrescue DVD ISO image
1161   remove_intermediate_iso_file
1162
1163   # remove the tmp dvdbackup folder of the DVD image
1164   remove_intermediate_dvdbackup_folder
1165
1166   # eject the DVD disk upon completion
1167   [ $ripdvd -eq 1 ] && eject -T $dev
1168
1169   date=`date`
1170   echo "$date DVD rip completed" | tee -a "$logfile"
1171
1172   if [[ -n "$mailto" ]]; then
1173     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1174   fi
1175
1176 fi
1177
1178 ##############################################################################################